package redis

import (
	"fmt"
	"github.com/go-redis/redis"
	"system_pay/setting"
)

var (
	Redisclient *redis.Client
	Nil         = redis.Nil
)

// Init 初始化连接
func Init(cfg *setting.RedisConfig) (err error) {

		Redisclient = redis.NewClient(&redis.Options{
			Addr:         fmt.Sprintf("%s:%d", cfg.Host, cfg.Port),
			Password:     cfg.Password, // no password set
			DB:           cfg.DB,       // use default DB
			PoolSize:     cfg.PoolSize,
			MinIdleConns: cfg.MinIdleConns,
		})


	_, err = Redisclient.Ping().Result()
	if err != nil {
		return err
	}
	return err
}

func Close() {
	_ = Redisclient.Close()
}
