package utils

import (
	"crypto/hmac"
	"crypto/sha256"
	"encoding/hex"
	"encoding/json"
	"errors"
	"github.com/astaxie/beego"
	"github.com/astaxie/beego/httplib"
	"system_pay/setting"
)

//func SignflowsGet(url, token string) (interface{}, error) {
//	Writelog(url, time.Now().Format("2006-01-02")+"SignflowsGetReq")
//	req := httplib.Get(url)
//	req.Header("X-Tsign-Open-App-Id", beego.AppConfig.String("PROJECT_ID"))
//	req.Header("X-Tsign-Open-Token", token)
//	req.Header("Content-Type", "application/json")
//	body, err := req.Bytes()
//	fmt.Println(string(body))
//	Writelog(string(body), time.Now().Format("2006-01-02")+"SignflowsGetReply")
//	if err != nil {
//		return nil, err
//	}
//	temp := make(map[string]interface{}, 0)
//	if err = json.Unmarshal(body, &temp); err != nil {
//		return nil, err
//	}
//	errCode, ok := temp["code"].(float64)
//
//	if ok != true {
//		return nil, errors.New("获取签署失败")
//	}
//
//	if errCode != 0 {
//		return nil, errors.New(temp["message"].(string))
//	}
//	return temp["data"], err
//}

//func SignHttpPost(url string, data map[string]interface{}, request string, response string) (map[string]interface{}, error) {
//	byte, _ := json.Marshal(data)
//	//Writelog(string(byte), time.Now().Format("2006-01-02")+request)
//	req := httplib.Post(url)
//	req.Header("X-Tsign-Open-App-Id", beego.AppConfig.String("PROJECT_ID"))
//	req.Header("X-Tsign-Open-App-Secret", beego.AppConfig.String("PROJECT_SECRET"))
//	req.Header("Content-Type", "application/json")
//	req.Body(byte)
//	body, err := req.Bytes()
//	//Writelog(string(body), time.Now().Format("2006-01-02")+response)
//	if err != nil {
//		return nil, err
//	}
//	temp := make(map[string]interface{}, 0)
//	if err = json.Unmarshal(body, &temp); err != nil {
//		return nil, err
//	}
//	return temp, err
//}
//
//, request string, response string
func OrganizeAuthPost(url string, data []byte) (map[string]interface{}, error) {
	//Writelog(url, time.Now().Format("2006-01-02")+"url")
	//Writelog(string(data), time.Now().Format("2006-01-02")+request)
	signature := ComputeHmacSha256(string(data), beego.AppConfig.String("PROJECT_SECRET"))
	req := httplib.Post(url)
	req.Header("X-timevale-mode", "package")
	req.Header("X-timevale-project-id", beego.AppConfig.String("PROJECT_ID"))
	req.Header("X-timevale-signature", signature)
	req.Header("X-timevale-signature-algorithm", "hmac-sha256")
	req.Header("Content-Type", "application/json")
	req.Body(data)
	body, err := req.Bytes()
	//Writelog(string(body), time.Now().Format("2006-01-02")+response)
	temp := make(map[string]interface{}, 0)
	if err = json.Unmarshal(body, &temp); err != nil {
		return nil, err
	}
	return temp, err
}

func ComputeHmacSha256(message string, secret string) string {
	key := []byte(secret)
	h := hmac.New(sha256.New, key)
	h.Write([]byte(message))
	sha := hex.EncodeToString(h.Sum(nil))
	return sha

}
//func HttpPost(url string, data []byte, request string, response string) (map[string]interface{}, error) {
//	Writelog(string(data), time.Now().Format("2006-01-02")+request)
//	req := httplib.Post(url)
//	req.Body(data)
//	body, err := req.Bytes()
//	Writelog(string(body), time.Now().Format("2006-01-02")+response)
//	if err != nil {
//		return nil, err
//	}
//	temp := make(map[string]interface{}, 0)
//	if err = json.Unmarshal(body, &temp); err != nil {
//		return nil, err
//	}
//	fmt.Println(temp)
//	return temp, err
//}
//
//func CreateData(url string, param map[string]interface{}) (interface{}, error) {
//
//	data, err := SignHttpPost(url, param, "", "")
//
//	if err != nil {
//		return nil, err
//	}
//
//	errCode, ok := data["errCode"].(float64)
//
//	if ok != true {
//		return nil, errors.New("CreateData转换失败")
//	}
//
//	if errCode != 0 {
//		return nil, errors.New(data["msg"].(string))
//	}
//
//	return data["data"], nil
//}
//
//func SendHttpPUT(url, contentBase64Md5 string, fileContent []byte) (map[string]interface{}, error) {
//	req := httplib.Put(url)
//	req.Header("Content-Type", "application/pdf")
//	req.Header("Content-Md5", contentBase64Md5)
//	req.Body(fileContent)
//	body, err := req.Bytes()
//	temp := make(map[string]interface{}, 0)
//
//	err = json.Unmarshal(body, &temp)
//
//	if err != nil {
//		return nil, err
//	}
//	return temp, err
//}
//
//func GetUploadurl(url string, param map[string]interface{}) (map[string]interface{}, error) {
//
//	filePath, ok := param["filePath"].(string)
//
//	if ok != true {
//		return nil, errors.New("文件直传filePath转换失败")
//	}
//
//	req := httplib.Get(filePath)
//	fileContent, err := req.Bytes()
//
//	uuidValue, err := uuid.NewV4()
//
//	if err != nil {
//		return nil, err
//	}
//
//	//产生文件唯一值
//	guid := uuidValue.String()
//	f, err := os.Create(guid + ".pdf")
//	defer f.Close()
//
//	if err != nil {
//		return nil, err
//	}
//	_, err = f.Write(fileContent)
//
//	fileSize := len(fileContent)
//
//	fileMd5, err := GetContentBase64Md5(guid + ".pdf")
//	if err != nil {
//		return nil, err
//	}
//
//	//删除文件
//	if err = os.Remove(guid + ".pdf"); err != nil {
//		return nil, err
//	}
//
//	param["fileSize"] = fileSize
//	param["contentType"] = "application/pdf"
//	param["contentMd5"] = fileMd5
//
//	data, err := CreateData(url, param)
//
//	if err != nil {
//		return nil, err
//	}
//
//	contentMd5, ok := fileMd5.(string)
//
//	if ok != true {
//		return nil, errors.New(languages.AssertionFailure)
//	}
//
//	if ok != true {
//		return nil, errors.New(languages.AssertionFailure)
//	}
//
//	uploadUrl, ok := data.(map[string]interface{})["uploadUrl"].(string)
//
//	if ok != true {
//		return nil, errors.New(languages.AssertionFailure)
//	}
//
//	uploadRes, err := SendHttpPUT(uploadUrl, contentMd5, fileContent)
//
//	if err != nil || uploadRes["errCode"].(float64) != 0 {
//		return nil, err
//	}
//
//	return data.(map[string]interface{}), nil
//}

//阿里云 - 全国快递物流查询
func SendHttpExpress(querys string) (map[string]interface{}, error) {
	//appcode := beego.AppConfig.String("AppCode")
	appcode := setting.Conf.AliCloud.AppCode
	//appcode = "6d1da9eb15b540688a505c1814e0c25f"
	//querys = "no=JDVB03807259358&type=JD" //example
	//querys = "no=432230466057007"
	url := "https://wuliu.market.alicloudapi.com/kdi?" + querys //url拼接
	//fmt.Println(appcode)
	//fmt.Println(url)
	req := httplib.Get(url)
	req.Header("Authorization", "APPCODE "+appcode)
	req.Body("")
	body, err := req.Bytes()

	temp := make(map[string]interface{}, 0)
	err = json.Unmarshal(body, &temp)
	//fmt.Println(temp)
	if err != nil {
		return nil, err
	}
	if temp["status"] != "0" {
		if temp["msg"]=="" {
			err = errors.New("物流信息取得失败")
		} else {
			err = errors.New(temp["msg"].(string))
		}
	}
	return temp, err
}
